<template>
    <q-dialog class="home">
        <q-card class="border-radius-50 q-pa-sm" style="width: 335px">
            <q-card-section class="row items-center row justify-center">
                <!-- Title -->
                <div class="col-12 items-center row justify-center">
                    <span
                        class="font-16 text-center helvetica-neue-medium"
                        no-caps
                    >
                        {{
                            tab == TabType.CHATTING || tab == TabType.CLIENTS
                                ? $t('home.assignTask')
                                : $t('home.transferChat')
                        }}
                    </span>
                </div>

                <!-- Search Bar -->
                <div class="col-12 q-mt-sm">
                    <q-input
                        bottom-slots
                        v-model="search"
                        rounded
                        outlined
                        :dense="dense"
                        :placeholder="$t('home.searchMember')"
                        bg-color="grey-3"
                        color="white"
                        :loading="state.loadingState"
                        debounce="500"
                    ></q-input>
                </div>

                <!-- Assign to Myself -->
                <q-item
                    flat
                    text
                    v-ripple
                    @click="joinConversation(convId, currentIndex)"
                    :disable="checkOwner()"
                    :clickable="!checkOwner()"
                    class="row justify-start items-center col-12 cursor-pointer"
                >
                    <q-item-section avatar class="q-pr-none">
                        <q-img
                            class="border-radius-50 user-border"
                            :src="
                                user.imageUrl
                                    ? user.imageUrl
                                    : '/images/default.png'
                            "
                        />
                    </q-item-section>

                    <div class="col-8 font-12 helvetica-neue-medium q-pl-sm">
                        {{ user.name }} ({{ $t('home.myself') }})
                    </div>
                </q-item>

                <!-- Team Member (Search Result) -->
                <div class="row justify-start items-center col-12">
                    <div class="col-12 q-ma-sm font-12 helvetica-neue-medium">
                        {{ $t('home.teamMember') }}
                    </div>
                    <div
                        class="row items-center col-12 assign-task-scroll"
                        v-if="state.searchResults"
                    >
                        <q-item
                            v-ripple
                            v-for="(member, index) in state.searchList"
                            v-bind:key="index"
                            @click="
                                tab == TabType.CHATTING
                                    ? conversationTransfer(
                                          member.user.id,
                                          currentIndex
                                      )
                                    : select(member.user.id)
                            "
                            :clickable="member.status == 2 ? false : true"
                            :disable="member.status == 2 ? true : false"
                            :class="
                                member.status == 1
                                    ? 'active row justify-center col-2 q-ml-sm q-mr-sm '
                                    : ' row justify-center col-2 q-ml-sm q-mr-sm '
                            "
                        >
                            <q-item-section avatar class="q-pr-none">
                                <q-img
                                    class="
                                        border-radius-50
                                        justify-center
                                        items-center
                                    "
                                    :class="
                                        member.user.id == state.selectedUserID
                                            ? 'border'
                                            : ''
                                    "
                                    :src="
                                        member.user.imageUrl
                                            ? member.user.imageUrl
                                            : '/images/default.png'
                                    "
                                >
                                    <q-tooltip
                                        anchor="center right"
                                        self="center middle"
                                        content-class="“my-tooltip-content”"
                                    >
                                        <div class="my-tooltip-content">
                                            {{ member.user.name }}
                                        </div>
                                    </q-tooltip>
                                </q-img>
                            </q-item-section>
                        </q-item>
                    </div>
                    <div
                        class="row col-12 q-ma-sm font-12 helvetica-neue-medium"
                        v-else
                    >
                        No Result
                    </div>
                    <div
                        class="col-12 text-center"
                        v-if="tab == TabType.ONGOING || tab == TabType.CLIENTS"
                    >
                        <q-btn
                            color="primary"
                            class="border-radius-10"
                            padding="8px 18px"
                            unelevated
                            @click="
                                conversationTransfer(
                                    state.selectedUserID,
                                    currentIndex
                                )
                            "
                        >
                            {{ $t('button.confirm') }}
                        </q-btn>
                    </div>
                </div>
            </q-card-section>
        </q-card>
    </q-dialog>
</template>

<script lang="ts">
import { TabType } from 'src/services/enums/TabType';
import { MemberListResponseResult } from 'src/services/responses/member/MemberListResponse';
import { useStore } from 'src/store';
import {
    computed,
    defineComponent,
    onMounted,
    reactive,
    ref,
    watch
} from 'vue';
import { mapGetters } from 'vuex';

export default defineComponent({
    computed: {
        ...mapGetters({
            issueTypes: 'issueType/getIssueTypesList',
            user: 'user/getUser'
        })
    },
    props: {
        confirm: {
            type: Boolean,
            required: true
        },
        convId: {
            type: String,
            required: true
        },
        ticketId: {
            type: String,
            required: false
        },
        currentIndex: {
            type: Number,
            default: 0
        },
        issuesType: {
            type: Object
        },
        tab: {
            type: String,
            required: true
        },
        conversationOwner: {
            type: String
        }
    },
    setup(props, { emit }) {
        const store = useStore();
        const search = ref('');

        let state = reactive({
            loadingState: ref(false),
            searchResults: ref(false),
            searchList: [] as any,
            issuesType: [] as any,
            selectedUserID: '',
            permissions: computed(() => {
                return store.state.role.permissions;
            }),
            belongToYourself: ref(false)
        });

        // Methods
        const joinConversation = async (conversationId: any, index: number) => {
            if (state.permissions?.conversation?.join == true) {
                let result: any;
                if (businessOwner()) {
                    result = await store.dispatch(
                        'conversation/transferConversation',
                        {
                            conversationId: conversationId,
                            userId: store.state.user.user?.id
                        }
                    );
                } else {
                    result = await store.dispatch(
                        'conversation/joinConversation',
                        {
                            conversationId
                        }
                    );
                }

                if (result.status == 200) {
                    emit('update-confirm', false);
                    state.issuesType = props.issuesType;
                    if (props.issuesType) {
                        let findResult = props.issuesType[index]['list'].filter(
                            function (item: any) {
                                return item.id !== conversationId;
                            }
                        );
                        let getResult = state.issuesType[index]['list'].filter(
                            function (item: any) {
                                return item.id == props.convId;
                            }
                        );

                        if (findResult) {
                            state.issuesType[index]['list'] = [];
                            findResult.forEach((element: any) => {
                                state.issuesType[index]['list'].push(element);
                            });
                            getResult.forEach((element: any) => {
                                store.dispatch(
                                    'conversation/putConversationsList',
                                    element
                                );
                            });
                            await store.dispatch(
                                'conversation/setConversationLength',
                                state.issuesType
                            );
                        }
                    }
                }
            }
        };

        const conversationTransfer = async (userId: any, index: number) => {
            if (
                state.permissions?.conversation?.transfer == true ||
                state.permissions?.conversation?.transferForce == true
            ) {
                const result: any = await store.dispatch(
                    'conversation/transferConversation',
                    {
                        conversationId: props.convId,
                        userId
                    }
                );

                if (userId && result.status == 200) {
                    emit('update-confirm', false);
                    state.issuesType = props.issuesType;

                    if (result.result.transfer == null) {
                        store.dispatch(
                            'conversation/removeConvoFromList',
                            props.convId
                        );
                    }

                    let type = {
                        ticketId: props.ticketId,
                        type: 'Transfer'
                    };
                    store.dispatch('conversation/setSelectedTicketID', type);
                    if (props.tab == TabType.CHATTING) {
                        let findResult = state.issuesType[index]['list'].filter(
                            function (item: any) {
                                return item.id !== props.convId;
                            }
                        );
                        if (findResult) {
                            state.issuesType[index]['list'] = [];
                            findResult.forEach((element: any) => {
                                state.issuesType[index]['list'].push(element);
                            });

                            await store.dispatch(
                                'conversation/setConversationLength',
                                state.issuesType
                            );
                        }
                        emit('update-convId', '');
                    } else if (props.tab == TabType.ONGOING) {
                        emit('update-convId', props.convId);
                        store.dispatch('conversation/unsetComponent', false);
                        store.dispatch('chat/unselectConversation');
                        store.dispatch('message/reset');
                        store.dispatch('message/resetHistory');
                        store.dispatch('note/clearNote');
                        store.dispatch('menu/setNoteDrawer', false);
                    } else {
                        store.dispatch(
                            'conversation/clearSelectedConversationID'
                        );
                        if (
                            state.permissions.conversation?.transferForce ==
                            true
                        ) {
                            store.dispatch('message/reset');
                        }
                        store.dispatch('chat/unselectConversation');
                        emit('update-convId', '');
                    }
                }
            }
        };

        const updateValue = (value: boolean) => {
            emit('update-confirm', value);
            return value;
        };

        const searchFunction = async (search: string) => {
            state.loadingState = true;

            const result: MemberListResponseResult = await store.dispatch(
                'member/searchMembers',
                {
                    page: 1,
                    limit: 10,
                    keyword: search,
                    branchIds: [store.state.branch.branch.id]
                }
            );

            if (result.members.length > 0) {
                state.loadingState = false;
                state.searchResults = true;

                state.searchList = result.members;
            } else {
                state.loadingState = false;
                state.searchResults = false;
            }

            removeOwner();
        };

        const select = (userID: string) => {
            state.selectedUserID = userID;
        };

        const checkOwner = () => {
            if (props.conversationOwner) {
                return props.conversationOwner == store.state.user.user?.id;
            }
            return false;
        };

        const removeOwner = () => {
            // Remove owner
            const findIndex = state.searchList.findIndex(
                (member: any) => member.user.id == store.state.user.user?.id
            );
            if (findIndex != -1) {
                state.searchList.splice(findIndex, 1);
            }
        };

        const businessOwner = () => {
            return store.getters['business/getBusiness'].member.isOwner;
        };

        const getMembers = () => {
            const result = store.state.member.list;

            if (result) {
                state.loadingState = false;
                state.searchResults = true;
                state.searchList = result;
            }
            removeOwner();
        };

        //  Watch
        watch(search, async (currentValue) => {
            if (currentValue) {
                await searchFunction(currentValue);
            } else {
                state.loadingState = false;
                state.searchResults = false;
                getMembers();
            }
        });

        watch(state.searchList, () => {
            removeOwner();
        });

        store.watch(
            (state) => state.member.list,
            () => {
                getMembers();
            }
        );

        onMounted(getMembers);

        return {
            state,
            joinConversation,
            search,
            dense: ref(true),
            conversationTransfer,
            updateValue,
            searchFunction,
            TabType,
            select,
            checkOwner
        };
    }
});
</script>
